function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function replaceInHtml(html, search, replacer) {
  "https://github.com/cutiful/replace-in-html";

  if (/(?:<html>|<head>|<body>)/.test(html)) throw new Error("`html` must not contain <html>, <head> or <body>");
  const re = typeof search === "string" ? aToRe(search) : search;
  if (!(re instanceof RegExp)) throw new Error("`search` must be a string or a RegExp");
  const fn = typeof replacer === "string" ? () => replacer : replacer;
  if (typeof fn !== "function") throw new Error("`replacer` must be a string or a function");
  const doc = new DOMParser().parseFromString(`<body>${html}</body>`, "text/html");
  const tw = doc.createTreeWalker(doc.body, 4); // text nodes only

  while (tw.nextNode()) replaceInCurrentNode(doc, tw, re, fn);

  return doc.body.innerHTML;
}

function replaceInCurrentNode(doc, tw, re, fn) {
  if (["SCRIPT", "STYLE", "TEXTAREA"].includes(tw.currentNode.parentElement.tagName)) return;
  let matches = tw.currentNode.data.match(re);
  if (matches === null) return;
  if (re.sticky || !re.global) // sticky ignores global
    matches = [matches[0]]; // the rest are capture groups

  var _iterator = _createForOfIteratorHelper(matches),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      const match = _step.value;
      const els = toElArr(fn(match), doc);
      const i = tw.currentNode.data.indexOf(match); // [siblings?] [<text?> <match> <text?>]
      //             ^ currentNode (was `next` in previous iteration)

      tw.currentNode.splitText(i);
      const target = tw.nextSibling(); // [siblings?] [<text?>] [<match> <text?>]
      //                       ^ currentNode = target

      tw.currentNode.splitText(match.length);
      const next = tw.nextSibling(); // [siblings?] [<text?>] [<match>] [<text?>]
      //                       ^ target  ^ currentNode = next

      target.parentElement.removeChild(target); // [siblings?] [<text?>] [<text?>]
      //                       ^ currentNode = next

      var _iterator2 = _createForOfIteratorHelper(els),
          _step2;

      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          const el = _step2.value;
          next.parentElement.insertBefore(el, next);
        } // [siblings?] [<text?>] [el] [el?] ... [<text?>]
        //                                      ^ currentNode

      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
}

function toElArr(els, doc) {
  if (typeof els === "string") {
    const div = doc.createElement("div");
    div.innerHTML = els;
    return [...div.childNodes];
  } else if (els instanceof HTMLCollection) {
    return [...els];
  } else if (Array.isArray(els)) {
    return els;
  } else if (els instanceof Node) {
    return [els];
  } else {
    throw new Error("`replacer` function must return string, Node, Array of Nodes or HTMLCollection");
  }
}

function aToRe(str) {
  return new RegExp(str.replace(/[.*+\-?^${}()|[\]\\]/g, "\\$&"), "g");
}

export { replaceInHtml as default };
